Mention notification is not sent (MENTION_PATTERN / LINKS_RE inconsistency)

2023-11-15 12:43 - Thomas Löber

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Email notifications Estimated time: 0.00 hour

Target version: 5.0.7   

Resolution: Fixed Affected version: 5.0.6

Description

Hi,

When I add an issue comment

Hello @login!

 where login is a valid login and there is no newline at the end of the comment, the mention is highlighted in the issue history, but no

notification is sent to the user.

This is because both, Redmine::Acts::Mentionable::InstanceMethods::MENTION_PATTERN and ApplicationHelper::LINKS_RE,

require a character after the exclamation mark, but only LINKS_RE (used in ApplicationHelper#parse_redmine_links) finds additional

characters, namely the </p>, which is added earlier when the comment is converted to HTML.

MENTION_PATTERN should handle the case that [[:punct:]] is the at end of the string.

Thanks,

Thomas

Associated revisions

Revision 22442 - 2023-11-16 22:55 - Marius BĂLTEANU

Add tests for #39553.

Revision 22443 - 2023-11-16 23:03 - Marius BĂLTEANU

Revert r22442 (#39553).

Revision 22444 - 2023-11-16 23:04 - Marius BĂLTEANU

Revert r22441 (#39553).

Revision 22445 - 2023-11-16 23:07 - Marius BĂLTEANU

Fix mention notification is not sent when user pattern is leading by some punctuation marks like ! or ? (#39553).

Patch by Thomas Löber.

Revision 22446 - 2023-11-16 23:08 - Marius BĂLTEANU

Cover more tests for #39553.

Revision 22447 - 2023-11-16 23:11 - Marius BĂLTEANU

Simply regex (#39553).

Revision 22448 - 2023-11-16 23:16 - Marius BĂLTEANU

Revert r22446 and r22447 (#39553).

Revision 22449 - 2023-11-16 23:17 - Marius BĂLTEANU

Cover more tests for #39553.
Revision 22450 - 2023-11-16 23:19 - Marius BĂLTEANU

Simply regex (#39553).

Revision 22451 - 2023-11-17 05:24 - Go MAEDA

Disable RuboCop warning for intentional comma in percent string array (#39553).

Revision 22454 - 2023-11-17 08:30 - Marius BĂLTEANU

Merged r22445, r22449 and r22450 from trunk to 5.1-stable (#39553).

Revision 22455 - 2023-11-17 08:30 - Marius BĂLTEANU

Merged r22445, r22449 and r22450 from trunk to 5.0-stable (#39553).

History

#1 - 2023-11-15 23:59 - Marius BĂLTEANU

- Status changed from New to Confirmed

- Assignee set to Marius BĂLTEANU

- Target version set to 5.0.7

#2 - 2023-11-16 01:26 - Marius BĂLTEANU

Indeed, the MENTION_PATTERN and LINKS_RE are not consistent right now, but I think in order to fix this more changes are needed.

Strict to the case reported by you, the following change should fix this:

diff --git a/lib/redmine/acts/mentionable.rb b/lib/redmine/acts/mentionable.rb

index e561e558f..10365ea86 100644

--- a/lib/redmine/acts/mentionable.rb

+++ b/lib/redmine/acts/mentionable.rb

@@ -100,6 +100,8 @@ module Redmine

           (?=

             (?=[[:punct:]][^A-Za-z0-9_\/])|

             ,|

+            !|

+            \?|

             \.+$|

             \s|

             \]|

 What do you think? If you have a better fix, please post it.

#3 - 2023-11-16 16:16 - Thomas Löber

I'd allow any optional punctuation character before the end of the string. This solves the problem also for characters different from ! and ?:

diff --git a/lib/redmine/acts/mentionable.rb b/lib/redmine/acts/mentionable.rb

--- a/lib/redmine/acts/mentionable.rb

+++ b/lib/redmine/acts/mentionable.rb

@@ -103,7 +103,7 @@

             \s|

             \]|

             <|

-            $)

+            [[:punct:]]?$)

         /ix

       end

     end

#4 - 2023-11-16 23:21 - Marius BĂLTEANU

- Status changed from Confirmed to Resolved

- Resolution set to Fixed

Thomas Löber wrote in #note-3:

I'd allow any optional punctuation character before the end of the string. This solves the problem also for characters different from ! and ?:

[...]
 Fix committed with udpated tests to cover these scenarios. Thanks for posting the patch.

#5 - 2023-11-17 08:31 - Marius BĂLTEANU

- Status changed from Resolved to Closed

Fixes merged to stable branches, sorry for the noise with the commits.
